<?php
if(!defined('ROOT')) die();
include_once('util.lib.php');
include_once('plugin.class.php');
include_once('show.lib.php');

######
###### fonctions internes
######

/*
** renvoie une valeur de configuration du core ou d'un plugin
*/
function getConfVal($plugin, $kConf){
	if($plugin == 'core') $file = ROOT.'data/config.txt';
	else $file = ROOT.'data/plugin/'.$plugin.'/config.txt';
	$config = json_decode(@file_get_contents($file), true);
	foreach($config as $k=>$v){
		if($k == $kConf) return $v;
	}
	return false;
}

/*
** renvoie la configuration du core
*/
function getCoreConf(){
	return json_decode(@file_get_contents(ROOT.'data/config.txt'), true);
}

/*
** enregistre la configuration du core
*/
function saveConfig($val, $append = array()){
	$config = json_decode(@file_get_contents(ROOT.'data/config.txt'), true);
	$config = array_merge($config, $append);
	foreach($config as $k=>$v){
		if(isset($val[$k])) $config[$k] = $val[$k];
	}
	if(@file_put_contents(ROOT.'data/config.txt', json_encode($config), 0666)) return true;
	return false;
}

/*
** appelle un hook
*/
function callHook($hookName){
	global $hooks;
	$return = '';
	if(isset($hooks[$hookName])) foreach($hooks[$hookName] as $function){
		$return.= call_user_func($function);
	}
	return $return;
}

/*
** ajoute un hook
*/
function addHook($hookName, $function){
	global $hooks;
	$hooks[$hookName][] = $function;
}

/*
** liste le dossier theme
*/
function listThemes(){
	$data = array();
	foreach(scandir(ROOT.'theme/') as $file) if(!is_dir($file) && $file[0] != '.'){
		$data[] = $file;
	}
	return $data;
}
/*
** detecte l'url de base
*/
function getSiteUrl(){
	$siteUrl = str_replace(array('install.php', '/admin/index.php'), array('', ''), $_SERVER['SCRIPT_NAME']);
	$siteUrl = 'http://'.$_SERVER['HTTP_HOST'].$siteUrl;
	$pos = mb_strlen($siteUrl)-1;
	if($siteUrl[$pos] == '/') $siteUrl = substr($siteUrl, 0, -1);
	return $siteUrl;
}
?>
